Bug 188926 - yum sometimes mismatches packages and repositories
yum sometimes mismatches packages and repositories
Status: CLOSED INSUFFICIENT_DATA
Product: Fedora
Classification: Fedora
Component: yum (Show other bugs)
5
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jeremy Katz
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2006-04-13 13:42 EDT by Toshio Kuratomi
Modified: 2014-01-21 17:53 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-09-18 16:26:17 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Yum repository file for k12ltsp (505 bytes, application/octet-stream)
2006-04-13 13:42 EDT, Toshio Kuratomi
no flags Details

  None (edit)
Description Toshio Kuratomi 2006-04-13 13:42:18 EDT
Description of problem:
This is an issue fo upstream yum.

When running a K12LTSP-5.0.0beta2 system,
yum install switchdesk
  fails with:
---> Downloading header for switchdesk to pack into transaction set.
http://k12linux.mesd.k12.or.us/K12LTSP/testing/5.0.0-32bit/Fedora/RPMS/switchdesk-4.0.8-4.noarch.rpm:
[Errno 14] HTTP Error 404: Date: Thu, 13 Apr 2006 16:24:16 GMT

Background:
This bug was found when using yum on the 5.0.0beta2 version of K12ltsp.

K12Ltsp integrates the Linux Terminal Server Project with Fedora Core in order
to run thin client computer labs at schools.  The maintainers have modified
fedora Core and produce their own repository that is a combination of vanilla
Fedora Core packages and packages which they have modified or added.  In the
setup where the problem was revealed, the Fedora Core repository is enabled
alongside the K12LTSP repository.  Because of this, there are many packages
which overlap in exact NEVR between the two.

Analysis:
The error generated with yum install switchdesk reveals something interesting:
http://k12linux.mesd.k12.or.us/K12LTSP/testing/5.0.0-32bit/Fedora/RPMS/switchdesk-4.0.8-4.noarch.rpm:

                                                        ^^^^^--- i386 is missing
A bit of research shows that the K12LTSP repository URL is:
  http://k12linux.mesd.k12.or.us/K12LTSP/testing/5.0.0-32bit/
and the switchdesk package <location> tag is
  <location>i386/Fedora/RPMS/switchdesk-4.0.8-4.noarch.rpm</location>

The Fedora Core repo has:
'http://redhat.download.fedoraproject.org/pub/fedora/linux/core/5/i386/os/'
<location href="Fedora/RPMS/switchdesk-4.0.8-4.noarch.rpm"/>

So it appears that yum is comparing packages using NEVR.  It finds two which are
 the same and assumes they are the same in all other respects.  Then yum uses
the location entry from the Fedora Core repo but attempts to pull the package
from the K12LTSP repo.  This leads to the lack of "i386" in the final URL.

Version-Release number of selected component (if applicable):
yum-2.6.0-1

How reproducible:


Steps to Reproduce:
1. Enable the K12LTSP-5.0.0beta2 repository on a Fedora Core 5 machine
2. yum -y erase switchdesk
3. yum -y install switchdesk
  
Actual results:
Package fails to install as detailed above.

Expected results:
Package would install

Additional info:
* Disabling either the Fedora Core or K12LTSP repo allows yum to pull the
package down.
* This does not occur with all packages (for instance, binutils matches the
correct location with the correct repository)
* I noticed that the repodata seems to be in an older format
<location></location> instead of <location href=""/>.  If this is the whole
reason, let me know and I'll just tell K12LTSP to run a newer createrepo on
their repository.
Comment 1 Toshio Kuratomi 2006-04-13 13:42:19 EDT
Created attachment 127718 [details]
Yum repository file for k12ltsp
Comment 2 Toshio Kuratomi 2006-04-14 13:44:34 EDT
Previous repository metadata was created with createrepo from CentOS.  The
metadata has now been updated so the <location href=""/> format is used.  The
problem continues so there is some wonkiness within yum.
Comment 3 Jeremy Katz 2006-04-19 16:46:12 EDT
This is related to the location stuff from paul and dennis
Comment 4 Warren Togami 2006-07-12 17:15:17 EDT
Any status update on this?
Comment 5 Paul Nasrat 2006-07-12 17:33:46 EDT
Dennis can you look into to ensure we do the right thing when we merge location
data.
Comment 6 Paul Nasrat 2006-07-12 17:44:49 EDT
Actually scratch that - this should be fixed with the per repo package sacks as
a result of the work in upstream yum - please test and see if it is fixed with
latest yum 2.9.x series as in rawhide.
Comment 7 Jeremy Katz 2006-09-18 16:26:17 EDT
Closing due to inactivity

Note You need to log in before you can comment on or make changes to this bug.